<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Validate credit cards
'*********************************************************************************

sub ShopValidatecreditcard (strocardno, strocardtype, SError)
   dim cctype, ctype, cclength, ccprefix, prefixes, lengths
   dim ccNumber, number, prefixvalid, lengthvalid, prefix
   dim cccheck, length, result, qsum, x, ch, sum, checkcc
   dim testtype
   ccType = ucase(left(StrocardType, 1))
   testtype = ucase(left(strocardtype, 5))
   if testtype = "DINER" then cctype = "I"

   '6.5.1 - added code to handle Maestro cards instead of interpreting them as Mastercards
   if testtype = "MAESTRO" then cctype = "S"

   ccnumber = strocardno
   ctype = ucase(cctype)
   select case ctype
      case "V" ' Visa
         cclength = "13;16"
         ccprefix = "4"
      case "M" ' Mastercard
         cclength = "16"
         ccprefix = "51;52;53;54;55"
      case "A" ' American express
         cclength = "15"
         ccprefix = "34;37"
      case "I" ' Diners
         cclength = "14"
         ccprefix = "300;301;302;303;304;305;36;38"
      case "D" ' discover/Novus
         cclength = "16"
         ccprefix = "6011"
      case "E" ' ?
         cclength = "15"
         ccprefix = "2014;2149"
      case "J" ' JCB
         cclength = "15;16"
         ccprefix = "3;2131;1800"
      case "C" ' Connect
         cclength = "16"
         ccprefix = "4539"
      case "S" ' Solo Switch
         cclength = "16;18;19" 'VP-ASP 6.50 - added extra card lengths
         ccprefix = "6767;6759;5641" 'VP-ASP 6.50.4 - added 6767 card prefix
      case "B" ' Bankcard
         cclength = "16"
         ccprefix = "5610"
      case else
         cclength = ""
         ccprefix = ""
   end select
   prefixes = split(ccprefix, ";", -1)
   lengths = split(cclength, ";", -1)
   number = trimtodigits(ccnumber)
   prefixvalid = false
   lengthvalid = false
   if ccprefix<>"" then
      for each prefix in prefixes
         if instr(number, prefix) = 1 then
            prefixvalid = true
         end if
      next
   else
      prefixvalid = true
   end if
   for each length in lengths
      if cstr(len(number)) = length then
         lengthvalid = true
      end if
   next
   result = 0
   if not prefixvalid then
      result = result + 1
   end if
   if not lengthvalid then
      result = result + 2
   end if
   qsum = 0
   for x = 1 to len(number)
      ch = mid(number, len(number) - x + 1, 1)
      if x mod 2 = 0 then
         sum = 2 * cint(ch)
         qsum = qsum + (sum mod 10)
         if sum>9 then
            qsum = qsum + 1
         end if
      else
         qsum = qsum + cint(ch)
      end if
   next

   if qsum mod 10<>0 then
      result = result + 4
   end if
   if cclength = "" then
      result = result + 8
   end if
   checkcc = result
   if checkcc<> 0 then
      SError = SError & GetLang("LangCheckoutError02") & "<br />"
      exit sub
   end if
   if right(strocardno, 8) = "11111111" then
      SError = SError & GetLang("LangCheckoutError02") & "<br />"
   end if
end sub

function trimtodigits(tstring)
   dim s,ts,x,ch
   'removes all chars except of 0-9
   s = ""
   ts = tstring
   for x = 1 to len(ts)
      ch = mid(ts, x, 1)
      if asc(ch)>= 48 and asc(ch)<= 57 then
         s = s & ch
      end if
   next
   trimtodigits = s
end function

sub ValidateExpiry
   dim mm
   dim yy
   dim yearnum, year, monthnum
   if len(strocardexpires)<>5 then
      SError = SError & GetLang("LangCheckoutExpiryError") & "<br />"
      exit sub
   end if
   mm = left(strocardexpires, 2)
   yy = right(strocardexpires, 2)
   if not isnumeric(mm) or not isnumeric(yy) then
      SError = SError & GetLang("LangCheckoutExpiryNum") & "<br />"
   end if
   if SError = "" then
      monthnum = month(date())
      year = datepart("yyyy", date())
      yearnum = right(year, 2)
      if clng(yearnum) = clng(yy) then
         if clng(monthnum)> clng(mm) then
            SError = SError & GetLang("LangInvaliddate") & "<br />"
         end if
      end if
   end if
end sub

sub ValidateCVN
   if len(strocardCVN) = 0 then exit sub
   if len(strocardCVN)<3 then
      SError = SError & GetLang("LangCheckoutCVNError") & "<br />"
      exit sub
   end if
   if len(strocardCVN)>4 then
      SError = SError & GetLang("LangCheckoutCVNError") & "<br />"
      exit sub
   end if
   if not isnumeric(strOCardCVN) then
      SError = SError & GetLang("LangCheckoutCVNError") & "<br />"
      exit sub
   end if
end sub

sub ValidateSWitch
   if ucase(strocardtype)<>"SWITCH" then exit sub
   if strocardissue = "" then
      SError = SError & "Issue number is required for Switch<br />"
   else
      if not isnumeric(strocardissue) then
         SError = SError & "Issue Number must be numeric" & "<br />"
      end if
   end if
end sub

' Generate a select list for months
function GenerateMM (name, currentvalue)
   dim value
   value = "<select name=""" & name & """ class=""txtfielddropdown"">"

   '6.50 - add blank option to top of list
   value = value & "<option>&nbsp;</option>"

   dim i, month, selected

   if currentvalue<>"" then
      month = currentvalue
   end if
   for i = 1 to 12
      name = i
      if len(name) = 1 then
         name = "0" & name
      end if
      if name = month then
         Selected = " selected=""selected"""
      else
         Selected = ""
      end if
      value = value & "<option " & selected & " value=""" & name & """>" & name & "</option>"
   next
   value = value & "</select>"
   generatemm = value
end function

' Generate a select list for Years
function GenerateYY (name, currentvalue)
   dim value
   dim i, year, currentyear, selected, yearpart
   value = "<select name=""" & name & """ class=""txtfielddropdown"">"

   '6.50 - add blank option to top of list
   value = value & "<option>&nbsp;</option>"

   year = datepart("yyyy", date())

   if currentvalue<>"" then
      currentyear = currentvalue
   end if
   for i = 1 to 10
      yearpart = right(year, 2)
      if currentyear = Yearpart then
         Selected = "selected=""selected"""
      else
         Selected = ""
      end if

      value = value & "<option " & selected & " value=""" & Yearpart & """>" & Yearpart & "</option>"
      year = year + 1
   next
   value = value & "</select>"
   Generateyy = value
end function

' if oid is lost, see if it really exists to protect against hacking
sub Checkvalidorder (poid)
   dim rs, sql, orderid, cardtype
   poid = request("oid")
   if poid = "" then
      exit sub
   end if
   if not isnumeric(poid) then
      poid = ""
      exit sub
   end if
   poid = clng(poid)
   sql = "select max(orderid) from orders"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   orderid = rs(0)
   CloseRecordSet rs
   sql = "select * from orders where orderid=" & orderid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      cardtype = rs("ocardtype")
      if isnull(cardtype) then cardtype = ""
   else
      cardtype = "unknown"
   end if
   CloseRecordSet rs
   if orderid = poid and cardtype = "" then
      SetSess "oid", poid
      exit sub
   end if
   poid = ""
end sub
%>